#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Wed 12 May 2010 03:38:08 PM CST

''' netatalk '''
import urllib
import urllib2
import hashlib
from service import *
from system import get_server_domain
from network import gethwaddr, getipaddr, getvpnip
from xml.dom.minidom import Node
from xml.dom.minidom import parseString
from info import _get_node_value, getseckey,DEVICEINFO 
from system import get_name_value
from system import set_name_value
from upnp import DEVICEINFO,UPNP_ENABLE
def setremote(enable=None, **kw):
    upnpconf = {}
    if enable == 'yes' :
        enableservice('sockproxy')
        restartservice('sockproxy')
        updateupnpinfo(opt='report')
        upnpconf = {UPNP_ENABLE : 'yes'}
    else:
        disableservice('sockproxy')
        stopservice('sockproxy')
        upnpconf = {UPNP_ENABLE : 'no'}
        updateupnpinfo()
    set_name_value(DEVICEINFO, upnpconf)
    return getremote()

def getremote(**kw):
    names = {}
    names['enable'] = servicestatus('sockproxy')
    names['running'] = servicestatus('sockproxy')
    return names

def updateupnpinfo(opt='clear', host=None, port='80'):
    hwaddr = gethwaddr().replace(':', '')
    if not hwaddr:
        raise NASError("No MAC Address")

    lanaddr = getipaddr()
    info = {'upnpaddr': ''}
    get_name_value(DEVICEINFO, info)
    upnpaddr = info['upnpaddr'] #upnpaddr already contains the port part

    seckey = getseckey()
    params = { 'key' : hwaddr }
    if opt == 'clear':
        params['upnp_addr'] = ''
        params['lan_addr'] = ''
    else:
        params['upnp_addr'] = upnpaddr
        params['lan_addr'] = lanaddr

    if seckey:
        keyinfo = hashlib.md5('%s:%s:%s' % (params['upnp_addr'], params['lan_addr'], seckey)).hexdigest()
        params['sec_key'] = keyinfo

    if not host:
        host = get_server_domain()
    url = 'http://%s:%s/gui/report_upnp_lan_addr' % (host, port)
    request = urllib2.Request(url, urllib.urlencode(params))
    try:
        data = urllib2.urlopen(request)
    except urllib2.HTTPError as error:
        raise NASError('Report UPnP Addr Fail', 'Server error response: %s' % error.code)
    except urllib2.URLError as error:
        raise NASError('Report UPnP Addr Fail', 'Connection Error: %s' % error.reason)
    except Exception as error:
        raise NASError('Report UPnP Addr Fail', repr(error))
    data.close()
    
def clearproxyinfo(name=None, host=None, port='80', **kw):
    hwaddr = gethwaddr().replace(':', '')
    if not hwaddr:
        raise NASError("No MAC Address")

    if name is None:
        name = hwaddr
    else:
        name = str(name)

    if host is None or not str(host):
        host = get_server_domain()
    else:
        host = str(host)

    param = {'key': '',
             'device_name': name,
             'openvpn': 'false'
             }
    seckey = getseckey()
    if seckey:
        sec_key = '%s:%s' % (name, seckey)
        param['sec_key'] = hashlib.md5(sec_key).hexdigest()

    url = 'http://%s:%s/gui/register_device' % (host, port)
    request = urllib2.Request(url, urllib.urlencode(param))
    print "Register parameters:", param
    try:
        data = urllib2.urlopen(request)
    except urllib2.HTTPError as error:
        raise NASError('Register Fail', 'Server error response: %s' % error.code)
    except urllib2.URLError as error:
        raise NASError('Register Fail', 'Connection Error: %s' % error.reason)
    except Exception as error:
        raise NASError('Register Fail', repr(error))

    content = data.read()
    print "Register Response: ", content
    data.close()
    resp = parseString(content)
    status = _get_node_value(resp, 'Status')
    reason = _get_node_value(resp, 'Reason')
    if status != '0':
        raise NASError('Register Fail', reason and reason or content)

    info = {'register': name}
    set_name_value(DEVICEINFO, info)

    return {'register': 'done'}

__all__ = ['getremote', 'setremote', 'deleteinfo', 'getseckey']

# vim: set sta sw=4 et:
