#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Wed 12 May 2010 03:38:08 PM CST

''' Thunder '''

from service import *
import system
from mlnet import setmlnet
from system import set_name_value
from system import _canwrite
from nas import check_public
import os
import info
from network import gethwaddr

if nas.system.getvendor() != 'akitio_cn':
    raise ImportError("Only akitio_cn support this feature.")
else:
    setmlnet(enable='no')

THUNDERCONF="/etc/nas/thunder.conf"
THUNDERCODEFILE="/var/www/nas/tdcode.inc"

def setthunder(enable=None, **kw):
    if enable is None:
        enable = servicestatus('thunder')
    else:
        enable = str(enable)
    check_public()
    if enable == 'yes' and _canwrite():
        enableservice('thunder')
        restartservice('thunder')
        checkdir()
    else:
        disableservice('thunder')
        stopservice('thunder')
    return getthunder()

def getthunder(**kw):
    names = {}
    names['enable'] = servicestatus('thunder')
    names['running'] = servicerunning('ETMDaemon')
    return names

def getcode():
    f = open(THUNDERCODEFILE, "r")
    try:
        thundercode = f.readline()
    finally:
        f.close()
    seckey = info.getseckey()
    mac = ''.join(gethwaddr().split(':'))
    code = thundercode.strip() + seckey[:13] + mac[-6:]
    data = {'license':code}
    set_name_value(THUNDERCONF,data) 

def checkdir(**kw):
    thunder_path = '/home/TDDOWNLOAD'
    if not os.path.exists(thunder_path):
        try:
            os.makedirs(thunder_path)
            system._makesure_dir(thunder_path, attr=0755, owner='admin', group='nas')
        except:
            pass
    path = '/home/downloads'
    if not os.path.islink(path):
        try:
            os.rename(path, '/home/download.bak')
        except:
            pass
    else:
        return
    try:
        os.symlink(thunder_path, path)
        os.system('chown  -R admin.nas %s' % path)
        os.chmod(path, 0777)
    except:
        pass
        
__all__ = ['getthunder', 'setthunder']

# vim: set sta sw=4 et:
