#!/usr/bin/python


import httplib
import urllib
import os
import system
import webdav

YOUTUBE_API='https://www.googleapis.com/upload/youtube/v3/videos?uploadType=resumable&alt=json&part=snippet%2Cstatus'

#JSON_INFO='''{"status": {"privacyStatus": "%s"}, "snippet": {"tags": %s, "categoryId": "%s", "description": "%s", "title": "%s"}}'''
JSON_INFO='''{"status": {"privacyStatus": "%s"}, "snippet": {"title": "%s"}}'''



def get_file_len(file_path):

    with open(file_path, 'r') as fd:
        fd.seek(0, 2)
        return fd.tell()


def upload(path=None, login=None, access_token=None, private='public', tag='null', categoryId='22', description='Video Description', title=None, **kw):

    if not path or not login or not access_token:
        raise system.StatusError(403)

    video_path = system.getrealpath(path, login, False)
    if not os.path.exists(video_path):
        raise system.StatusError(403)
    

    host, _, url = YOUTUBE_API.partition(':')
    host, uri = urllib.splithost(url)
    conn = httplib.HTTPSConnection(host)
    conn.set_debuglevel(5)

    if not title:
        title = os.path.split(video_path)[1] 
 
    post_data = JSON_INFO % (private, title)
    print post_data
    
    headers = {}
    
    file_length = get_file_len(video_path)
    headers['Host'] = host
    headers['content-length'] = len(post_data)
    headers['accept-encoding'] = "gzip, deflate"
    headers['accept'] = "application/json"
    headers['user-agent'] = "wks-isharing-client"
    headers['x-upload-content-length'] = file_length
    import mimetypes
    headers['x-upload-content-type'] = mimetypes.guess_type(video_path)[0]
    headers['content-type'] = "application/json"
    headers['authorization'] = 'Bearer %s' % access_token

    conn.request('POST', uri, post_data, headers)
    status = None
    headers = []
    content = ''
    
    try:
        resp = conn.getresponse()
        status = resp.status
        location = resp.getheader('Location')
        headers = resp.getheaders()
        content = resp.read()
        resp.close()
    except Exception as error:
        raise system.NASError(content)

    host, _, url = location.partition(':')
    host, uri = urllib.splithost(url)
    conn.putrequest('PUT', uri)
    conn.putheader('authorization', 'Bearer %s' % access_token)
    conn.putheader('Content-length', file_length)
    fd = open(video_path, 'rb')
    try:
        conn.endheaders()
        conn.send(fd)
        resp = conn.getresponse()
        status = resp.status
        headers = resp.getheaders()
        content = resp.read()
    except Exception as error:
        raise system.NASError(content)
    finally:
        fd.close()
    raise webdav.StatusComplete(status, headers, content)

