﻿$(function(){
	window.App="DiskManager";
	layout();
	loadLang();
	loadData();
	bindEvent();

});


function layout(){

	$("#DESTROY,#REBUILD,#CREATE").hide();

	window.Layout = $('body').layout({ 
			center__paneSelector:"#main" 
		,	north__paneSelector:"#top" 
		,	north__size:60
		,	north__spacing_open:0
		,	west__paneSelector:	"#left" 
		,	west__size:	260
		,	west__spacing_open:	0
		,	contentSelector:".content"
		//,	center__onresize_end: function(){ }
	}); 
	
	
	$('#toolbar').toolbar();
	window.$PARTITIONS=$("#partitions");
	window.RAIDPATHS=[]; 
	
	window.grid=$("#raidlist table:first")[0];
	$(window.grid).flexigrid({
		singleSelect:true
		,colModel : [
			{display: '<label domain="l10n" msgid="DiskManager_table_operation"></label>', name : 'Delete', width : 50, sortable : false, align: 'left'}
			,{display: '<label domain="l10n" msgid="DiskManager_table_path"></label>', name : 'Path', width : 200, sortable : false, align: 'left'}
			,{display: '<label domain="l10n" msgid="DiskManager_table_size"></label>', name : 'Size', width : 200, sortable : false, align: 'left'}
		]
	});
	$("ul.tabs a:eq(1)").click(function(){	window.grid.grid.Resize();	});

}
	

function bindEvent(){
	//$("#AUTO").click(autoDisks);
	$("#INFO").click(showInfoWin);
	$("#FORMAT").click(showFormat);
	$("#MOUNT").click(showMount);
	$("#UNMOUNT").click(unmountPartition);
	$("#FORMATPARTITION").click(formatPartition);
	$("#ERASE").click(toErase);
	$("#SMART").click(showSmart);
	//$("#ERASEDEVICE").click(function(){	$("#ERASE").click();	});
	$("#CREATEPARTITION").click(createPartition);
	$("#DELETE").click(deletePartition);
	//$("#DELETEPARTITION").click(deletePartition);
	$("#MOUNTPARTITION").click(mountPartition);
	$("#mountasashome").click(function(){	if($(this).attr('checked'))$("#mountpoint").val('home').attr('disabled','disabled');else $("#mountpoint").val('').removeAttr('disabled'); 	});
	$("#CLEAR").click(clearRaid);
	$("#DESTROY").click(destroyRaid);
	$("#REFRESH").click(loadData);
	$("#OPTION").click(showOption);
	$("#CREATE").click(createRaid);
	$("#DETECT").click(detectRaid);
	$("#REBUILD").click(rebuildRaid);
	$("#DISKMAN li").mousedown(function(){
		if($.inArray(this.id,['INFO','SMART','REFRESH','OPTION'])===-1){$('ul.tabs a:first').click();$('#devicelist a.selected').click();}
	});
	$('#raidlist').droppable({
			accept:'#devicelist a'
			,drop: function(event, ui) {
				addPartitionToRaidList(ui.draggable[0]);
			}
			,hoverClass: 'drophover'
	}); 
	$("#partitionsize").change(function(){
		var v=$(this).val();
		toCalculatePartition();
	});
	$(window).resize(function(){ window.setTimeout(function(){$('div.pointer',window.$PARTITIONS).trigger('resize');},200); });//??
}

function loadData(){
	//if(!toValidate())return;

	var d=$('#devicelist a.selected')[0];
	if(d)d={device:($(d).hasClass('device')?'first':'last'), path:d.data.path};
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/devices"
		,cache:false
		,data:{
			hash:window.top.SessionID
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
			if(d)$("#devicelist a[path="+d.path+"]:"+d.device).click();
		}
		,error:function(data){
				$("#waiting").hide();
				alert ( $.l10n.__("global_alert_getdataerror") );
		}
		//,timeout:20000
		
	});
}


function parseData(data, node){
	window.noswap=true;
	if(node)node=$(node).attr('path');

	$("#devicelist").html('<ul class="disklist"></ul>');
	window.$TREE=$("#devicelist ul");
	window.$TREE.treeview({collapsed:false});

	var raids=[];
	$('device',data).each(function(){
		if($('>raid',this).length>0){
			raids.push($('>path',this).text());
		};
	});

	$('device',data).each(function(){
		if($('length:first',this).text()!='0'){
			var li=document.createElement("li");
			var a=document.createElement("a");
			a.data={		
				path:$(this).children('path').text()
				,serial:$(this).children('serial').text()
				,model:$(this).children('model').text()
				,connectiontype:$(this).children('connectiontype').text()
				,cylinder:$(this).children('cylinder').text()-0
				,head:$(this).children('head').text()-0
				,sector:$(this).children('sector').text()-0
				,length:$(this).children('length').text()-0
				,sectorsize:$(this).children('sectorsize').text()-0
				,partitions:$(this).children('partition')
				,raid:$(this).children('raid')
				,start:0
				,raidmember:$(this).children('raidmember').text()
				,type:$(this).children('type').text()
			};
			//??
			if($.inArray(a.data.raidmember,raids)>-1)$(a).addClass('raidlive');

			a.data.size=a.data.length*a.data.sectorsize;
			a.innerHTML=a.data.model; 
			a.className="device";
			if(a.data.raidmember!=='')$(a).addClass('raidpart');
			a.setAttribute('path',a.data.path)
			var ul=document.createElement("ul");
			var eul=document.createElement("ul");
			
			var l=a.data.length;
			var ps=a.data.partitions;
			
			
			for(var i=0;i<ps.length;i++){
				var p=$(ps[i])
				var pdata={		
					path:$('path',p).text()
					,available:$('available',p).text()
					,used:$('used',p).text()
					,usedpercent:($('usedpercent',p).text()===''?'0%':$('usedpercent',p).text()+'%')
					,label:$('label',p).text()
					,mountpoint:$('mountpoint',p)
					,mountpointtext:''
					,start:$('start',p).text()-0
					,end:$('end',p).text()-0
					,length:$('length',p).text()-0
					,type:$('type',p).text()
					,flags:$('flags',p).text()
					,fs:$('fs',p).text()
					,raidmember:$('raidmember',p).text()
					,device:a
				};

				
			
				if(pdata.type==='extended'){
					var extended_start=pdata.start;
					var extended_end=pdata.end;
				}
				
				pdata.size=pdata.length*pdata.device.data.sectorsize;
				var pli=document.createElement("li");
				var pa=document.createElement("a");
				pa.data=pdata;
				pa.innerHTML= ((pa.data.label=="")?pa.data.path : pa.data.label)+' '+formatBytes(pa.data.size);//+'('+pa.data.usedpercent+')';

				//??
				if($.inArray(pa.data.raidmember,raids)>-1)$(pa).addClass('raidlive');

				//if(data.type==='extended')pa.innerHTML='<label domain="l10n" msgid="DiskManager_text_extended>'+$.l10n.__('DiskManager_text_extended')+'</label>';
				if(pa.data.type==='extended')pa.innerHTML='Extended Partitions';
				pa.setAttribute('path',pa.data.path)
				$(pa).addClass(pa.data.type);
				if(pa.data.mountpoint.length>0){
					$(pa).addClass('mounted');
					$(pa.data.device).addClass('hasmounted');
					$(pa.data.mountpoint).each(function(){
						pa.data.mountpointtext += $(this).text()+","
					});
				}
				if(pa.data.fs==='swap'&&pa.data.mountpointtext!=='')window.noswap=false;
				if(pa.data.fs!='')$(pa).addClass('formatted');
				if(pa.data.raidmember!==''){
					$(pa).addClass('raidpart');
					$(a).addClass('hasraidpart');
				}
				if(a.data.raid.children().length>0)$(pa).addClass('raidpartition');
				if(pa.data.type==='logic'){
					$(pli).append(pa).appendTo(eul);
				}
				else{
					$(pli).append(pa).appendTo(ul);	
				}
				
				if(pa.data.type==='extended'){
					$(pa).after(eul);
				}
		}
		
			
			
		a.partitions=ul;		
		if(a.data.type!==''||a.data.model==='Linux Soft RAID'){//??
			$(li).append(a).append(ul).appendTo(window.$TREE);
		}
		else{			
			$(a).addClass('fail');
			$(li).append(a).append('<ul><li><a><span class="failed">Unknown Device!</span></a></li></ul>').appendTo(window.$TREE);
		}
		if(a.data.raid.children().length>0){
			$(a).addClass('raiddevice');
			if($('syncpercent',a.data.raid).length>0){
				var syncpercent=$('syncpercent',a.data.raid).text();
				var syncname=$('sync',a.data.raid).text();
				syncname=syncname.split(syncpercent);
				syncname=syncname[0].split(']');
				syncname=syncname[syncname.length-1];
				syncname=syncname.replace('=','').replace(/\s/g,'');
				$(a).append(' <span>['+syncname+':'+syncpercent+']</span>')
			}
			if(a.data.partitions.length>0)$(a).addClass('hasraidpartitions');
		}
		window.$TREE.treeview({add:$(li)});
	}
		if(window.noswap)$('#noswap').show();
		else{$('#noswap').hide();}
		//收集自由空间
		if($('a.extended',ul).length>0){
			var ps_start=extended_start;//a.data.length;
			var ps_end=extended_end;
			var $pe=$('a.logic',ul);
			if($pe.length>0){
				for(var i=0,pel=$pe.length;i<pel;i++){
					ps_end=$pe[i].data.start;
					if(ps_end-ps_start>(8*1024*1024/a.data.sectorsize)){
						var fsli=document.createElement("li");
						var fsa=document.createElement("a");
						$(fsa)
							.addClass('freelogic')
							.attr('path','freelogic_'+ps_start)
							.html("Free Space");
						fsa.data={
							path:'freelogic_'+ps_start
							,type:'freelogic'
							,device:a
							,start:ps_start
							,length:ps_end-ps_start+1
							,size:(ps_end-ps_start+1)*a.data.sectorsize
							,sectorsize:a.data.sectorsize
							,available:(ps_end-ps_start+1)*a.data.sectorsize
							,used:''
							,usedpercent:''
							,label:''
							,mountpointtext:''
							,flags:''
							,fs:''
						}
						$(fsli).append(fsa).appendTo(eul);
						$($pe[i].parentNode).before(fsli);
					}
					ps_start=$pe[i].data.end+1;
					if(i===pel-1){
						ps_end=extended_end; 
						if(ps_end-ps_start>(8*1024*1024/a.data.sectorsize)){
							var fsli=document.createElement("li");
							var fsa=document.createElement("a");
							$(fsa)
								.addClass('freelogic')
								.attr('path','freelogic_'+ps_start)
								.html("Free Space");
							fsa.data={
								path:'freelogic_'+ps_start
								,type:'freelogic'
								,device:a
								,start:ps_start
								,length:ps_end-ps_start+1
								,size:(ps_end-ps_start+1)*a.data.sectorsize
								,sectorsize:a.data.sectorsize
								,available:(ps_end-ps_start+1)*a.data.sectorsize
								,used:''
								,usedpercent:''
								,label:''
								,mountpointtext:''
								,flags:''
								,fs:''
							}
							$(fsli).append(fsa).appendTo(eul);
						}
					}
				}
			}
			else{
				var fsli=document.createElement("li");
				var fsa=document.createElement("a");
				$(fsa)
					.addClass('freelogic')
					.attr('path','freelogic_'+ps_start)
					.html("Free logic["+(ps_end-ps_start+1)+']');
				fsa.data={
					path:'freelogic_'+ps_start
					,type:'freelogic'
					,device:a
					,start:ps_start
					,length:ps_end-ps_start+1
					,size:(ps_end-ps_start+1)*a.data.sectorsize
					,sectorsize:a.data.sectorsize
					,available:(ps_end-ps_start+1)*a.data.sectorsize
					,used:''
					,usedpercent:''
					,label:''
					,mountpointtext:''
					,flags:''
					,fs:''
				}
				$(fsli).append(fsa).appendTo(eul);
			}
		}
		
		var ps_start=0;//a.data.length;	
		var ps_end=a.data.length;
		var $pe=$('a.primary, a.extended',ul);
		if($pe.length>0){
			for(var i=0,pel=$pe.length;i<pel;i++){
				ps_end=$pe[i].data.start;
				if(ps_end-ps_start>(8*1024*1024/a.data.sectorsize)){
					var fsli=document.createElement("li");
					var fsa=document.createElement("a");
					$(fsa)
						.addClass('freespace')
						.attr('path','freespace_'+ps_start)
						.html("Free Space");
					fsa.data={
						path:'freespace_'+ps_start
						,type:'freespace'
						,device:a
						,start:ps_start
						,length:ps_end-ps_start+1
						,size:(ps_end-ps_start+1)*a.data.sectorsize
						,sectorsize:a.data.sectorsize
						,available:(ps_end-ps_start+1)*a.data.sectorsize
						,used:''
						,usedpercent:''
						,label:''
						,mountpointtext:''
						,flags:''
						,fs:''
					}
					$(fsli).append(fsa).appendTo(ul);
					$($pe[i].parentNode).before(fsli);
				}
				ps_start=$pe[i].data.end+1;
				if(i===pel-1){
					ps_end=a.data.length;
					if(ps_end-ps_start>(8*1024*1024/a.data.sectorsize)){
						var fsli=document.createElement("li");
						var fsa=document.createElement("a");
						$(fsa)
							.addClass('freespace')
							.attr('path','freespace_'+ps_start)
							.html("Free Space");
						fsa.data={
							path:'freespace_'+ps_start
							,type:'freespace'
							,device:a
							,start:ps_start
							,length:ps_end-ps_start+1
							,size:(ps_end-ps_start+1)*a.data.sectorsize
							,sectorsize:a.data.sectorsize
							,available:(ps_end-ps_start+1)*a.data.sectorsize
							,used:''
							,usedpercent:''
							,label:''
							,mountpointtext:''
							,flags:''
							,fs:''
						}
						$(fsli).append(fsa).appendTo(ul);
					}
				}
			}
		}
		else{	
			var fsli=document.createElement("li");
			var fsa=document.createElement("a");
			$(fsa)
				.addClass('freespace')
				.attr('path','freespace_'+ps_start)
				.html("Free Space");
			fsa.data={
				path:'freespace_'+ps_start
				,type:'freespace'
				,device:a
				,start:ps_start
				,length:ps_end-ps_start+1
				,size:(ps_end-ps_start+1)*a.data.sectorsize
				,sectorsize:a.data.sectorsize
				,available:(ps_end-ps_start+1)*a.data.sectorsize
				,used:''
				,usedpercent:''
				,label:''
				,mountpointtext:''
				,flags:''
				,fs:''
			}
			$(fsli).append(fsa).appendTo(ul);
		}
		
	});
	
	$(' a.freespace',$('a.device.raidpart',$TREE).next()).parent().remove();//??隐藏raidpart的freespace

	$('a',window.$TREE).click(function(){
		$('a.selected',window.$TREE).removeClass('selected');
		$(this).addClass('selected'); 
		enableToolbar();
		showInfo(); 
	});

	$("a.primary, a.logic, a.device",window.$TREE).draggable({
	// 只做磁盘的 RAID
	//$("a.device",window.$TREE).draggable({
		helper: 'clone'
		,appendTo: '#dragging'
		,cursor:'move'
		,revert:true
		//,start:function(){	}
		//,stop:function(){	}
	});
	
	
	if(node){
		$('a[path='+node+']',window.$TREE).click();
	}
	else{
		$('a.device:first',window.$TREE).click();
	}
}






function enableToolbar(){
	$('#top ul li').removeClass('enabled');
	$('#INFO').addClass('enabled');
	$('#REFRESH,#OPTION').addClass('enabled');
	var $n=$('a.selected',window.$TREE);
	if($n.hasClass('device')){//??$n.hasClass('raidlive')
			if(!( $n.hasClass('raidpart') || $n.hasClass('hasraidpart')  || $n.hasClass('mounted') || $n.hasClass('hasmounted') ) )$('#ERASE').addClass('enabled');
			if(!$n.hasClass('raiddevice'))$('#SMART').addClass('enabled'); 
	}else{
		if($n.hasClass('primary')||$n.hasClass('logic')){//?? raidpart 去掉可以删除  $n.hasClass('raidlive')
			if(   !( $n.hasClass('raidpart') || $n.hasClass('mounted') ) ){
				//if(!$n.hasClass('raidpartition'))??
				$('#DELETE').addClass('enabled');
				$('#FORMAT').addClass('enabled');
			}
			if($n.hasClass('mounted'))$('#UNMOUNT').addClass('enabled');
			else {
				if($n.hasClass('formatted'))$('#MOUNT').addClass('enabled');
			}
		}
		if($n.hasClass('extended')){
			$('#DELETE').addClass('enabled');
		}
		if($n.hasClass('freespace')){
			//
		}
	}
}


function showInfoWin(){
	var $n=$('a.selected',window.$TREE);
	if($n.hasClass('device'))window.top.DiskManager.showInfo( $('#deviceinfo').html() );
	else window.top.DiskManager.showInfo( $('#partitioninfo').html() );
}


function showInfo(){
	$("tr",window.grid).remove();
	$("#tables table").hide();
	$('#raidinfo').html('');
	$("#DESTROY,#REBUILD").hide();
	$("#CREATE").show();
	$("tr",window.grid).remove();	
	var $n=$('a.selected',window.$TREE);
	var n=$n[0];
	var data=n.data;
	if(!data)return;
	if($n.hasClass('device')){
		$("#Dpath").html(data.path);
		$("#Dserial").html(data.serial);
		$("#Dmodel").html(data.model);
		$("#Dlength").html(formatBytes(data.size) +" ("+ data.size +" bytes)");
		$("#Dconnectiontype").html(data.connectiontype);
		$("#Dcylinder").html(data.cylinder);
		$("#Dhead").html(data.head);
		$("#Dsector").html(data.sector);
		$("#Dsectorsize").html(formatBytes(data.sectorsize));
		$("#Dmodel").html(data.model);
		$("#deviceinfo").show();
		if($n.hasClass('raiddevice')){
			$("#DESTROY,#REBUILD").show();
			$("#CREATE").hide();
			$('#raidinfo').html('<pre><code>'+$('sync',data.raid).text()+'\n'+$('detail',data.raid).text()+'</code></pre>').show();
			$("#raidtypelist option[value="+$('level',data.raid).text().replace('raid','')+"]").attr('selected','selected');
			$('raiddevice',data.raid).each(function(){
				addPartitionToRaidList( $(this).text()  );
			 });
		}
		showPartitionMap(n);
	}else{
		$("#Ppath").html(data.path);
		$("#Plabel").html(data.label);
		$("#Pmount").html(data.mountpointtext);
		$("#Plength").html(formatBytes(data.size) +" ("+ data.size +" bytes)");
		$("#Pfs").html(data.fs);
		$("#Ptype").html(data.type);
		$("#Pflags").html(data.flags);
		$("#Ppath").html(data.path);
		$("#Pavailable").html(formatBytes(data.available));
		$("#Pused").html(formatBytes(data.used)+'('+data.usedpercent+')');
		$("#PusedMap div").css({width:data.usedpercent});
		if(window.noswap)$("#partitioninfo").hide();
		else $("#partitioninfo").show();
		showPartitionMap(n.data.device);
		var $pmap=$("div[path="+data.path+"]",window.$PARTITIONS)
		$("div",window.$PARTITIONS).removeClass('selected');
		$pmap.addClass('selected');
		$('div.pointer',window.$PARTITIONS).show().unbind('resize').bind('resize',function(){   $(this).css({top:$pmap.position().top-3,left:-3,width:$pmap.width(), height:$pmap.height()});     }).trigger('resize');
		
		if(data.fs==='')$('#FORMAT').click();
		if(data.fs!==''&&data.mountpointtext==='')$('#MOUNT').click();
		if(data.type==='freespace'||data.type==='freelogic'){
			//if($(data.device).hasClass('raiddevice')){??
				//$("#table_format").show();??
			//}
			//else {
				$("#partitionsize")[0].data={
					length:data.length
					,sectorsize:data.sectorsize
					,devicelength:data.device.data.length
				};
				$("#partitionsize").val(  formatBytesNumber( data.length*data.device.data.sectorsize,2)   );
				$("#partitionbytes").html(formatBytes(data.length*data.device.data.sectorsize));
				$("#partitiontypelist").empty();
				$("#table_partition").show();
				if(data.type==='freespace'){
					$('#table_partition').show();
					var primarys=$('a.primary',data.device.parentNode).length;
					var extendeds=$('a.extended',data.device.parentNode).length;
					if(primarys<4){
						$("#partitiontypelist").append('<option value="primary" domain="l10n" msgid="DiskManager_text_primary">'+$.l10n.__('DiskManager_text_primary')+'</option>');
					}
					if(extendeds===0&&primarys>=1){
						$("#partitiontypelist").append('<option value="extended" domain="l10n" msgid="DiskManager_text_extended">'+$.l10n.__('DiskManager_text_extended')+'</option>');
					}
					if( primarys+extendeds ===4 ){
						$("#partitiontypelist").empty();
						$("#table_partition").hide();
					}
				}
				if(data.type==='freelogic'){
					$("#partitiontypelist").append('<option value="logic" domain="l10n" msgid="DiskManager_text_logic" selected="selected">'+$.l10n.__('DiskManager_text_logic')+'</option>');
				}
			//}
		}
	} 
}




function showFormat(){
	if(!$("#FORMAT").hasClass('enabled'))return;
	//$('#INFO').addClass('enabled');
	$("#tables table").hide();
	if(!window.noswap)$("#partitioninfo").show();
	$("#table_format").show();
	var $n=$('div.selected',window.$PARTITIONS);
	var n=$n[0];
	if(n){
		$("#vloumelabel").val(n.data.label);
		$("#fslist option[valeu="+n.data.fs+"]").attr('selected','selected');
	}
}

function showMount(){
	if(!$("#MOUNT").hasClass('enabled'))return;
	//$('#INFO').addClass('enabled');
	$("#tables table").hide();
	if(!window.noswap)$("#partitioninfo").show();
	$("#table_mount").show();
	var a=$('a.selected',window.$TREE)[0];
	if (a.data.fs==='swap'){
		$("#mountpoint").val('').attr('disabled','disabled');
		$("#mountasashome").removeAttr('checked').attr('disabled','disabled');
	}
	else{
		$("#mountpoint").val('').removeAttr('disabled');
		$("#mountasashome").removeAttr('disabled').removeAttr('checked');
	}
}


function showPartitionMap(device){
	var $PS=window.$PARTITIONS;
	$PS.html('');
	var ps=$('ul li a',device.parentNode);//device.data.partitions; 


	for(var i=0;i<ps.length;i++){
		var data=$(ps[i])[0].data;
		if(!data)continue;
		var div=document.createElement('div');
		div.data=data;
		$(div)
			.addClass(data.type)
			.append('<div class="used" style="height:'+data.usedpercent+';"></div><table style="height:100%;" cellpadding="0" cellspacing="0"><tr><td align="center" valign="center"></td></tr></table>')
			.attr('path',data.path)
			.css({
				position:"absolute"
				,top:((data.start-1)/data.device.data.length*100).toFixed(4) +"%"
				,height:(data.length/data.device.data.length*100).toFixed(4) +"%"
			})
			.appendTo($PS);
	}
	$('div',$PS).each(function(){
		if($(this).hasClass('primary')||$(this).hasClass('logic')){
			$('td',this).html(this.data.path + ( (this.data.fs=="")?"":" ("+this.data.fs+")" ));
		}
		if($(this).hasClass('freespace')||$(this).hasClass('freelogic')){
			$('td',this).html('Free Space');
		}
		$(this).click(function(){
			$("a[path="+this.data.path+"]",window.$TREE).click();
		});
	});
	$PS.append('<div class="pointer"></div>');
}





function toErase(){
	if(!$("#ERASE").hasClass('enabled')){
		return;
	}
	var p=$("a.selected",window.$TREE)[0];
	if(confirm($.l10n.__('DiskManager_alert_erase'))){
		if(confirm($.l10n.__('DiskManager_alert_data_lost'))){	
			$("#waiting").show();
			$.ajax({
				url: window.top.remoteDataUrl+"nas/delete/partitions"
				,cache:false
				,data:{
					hash:window.top.SessionID
					,path:p.data.path
				}
				,type: "POST"
				,dataType:"xml"
				,success: function(data){
					$("#waiting").hide();
					if(window.top.checkAPIError(data))return;
					parseData(data, p);
				}
				,error:function(data){
					$("#waiting").hide();
					alert ( $.l10n.__("global_alert_getdataerror") );
				}
				//,timeout:20000
				
			});
		}
	}
}



function createPartition(){
	var $p=$("a.selected",window.$TREE);
	var p=$p[0];
	toCalculatePartition();
	var $pt=$("#partitionsize");
	var pt=$pt[0];
	var length=parseInt($pt.val()*1024*1024/p.data.sectorsize); 
	if (length>pt.data.length)length=pt.data.length;

	$("#waiting").show(); 
	$.ajax({
		url: window.top.remoteDataUrl+"nas/add/partition"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,path:p.data.device.data.path
			,start:p.data.start 
			,length: length//??
			,type:$("#partitiontypelist").val()
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data, p.data.device);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
		//,timeout:20000
		
	});
}





function deletePartition(){
	if(!$('#DELETE').hasClass('enabled'))return;
	var $p=$("a.selected",window.$TREE);
	var p=$p[0];
	if(confirm($.l10n.__('DiskManager_alert_deletepartition'))){
		if(confirm($.l10n.__('DiskManager_alert_data_lost'))){	
			$("#waiting").show();
			$.ajax({
				url: window.top.remoteDataUrl+"nas/delete/partition"
				,cache:false
				,data:{
					hash:window.top.SessionID
					,path:p.data.path
				}
				,type: "POST"
				,dataType:"xml"
				,success: function(data){
					$("#waiting").hide();
					if(window.top.checkAPIError(data))return;
					parseData(data, p.data.device);
				}
				,error:function(data){
					$("#waiting").hide();
					alert ( $.l10n.__("global_alert_getdataerror") );
				}
				//,timeout:20000
				
			});
		}
	}
}

function formatPartition(){  
	if(!toValidateFormat())return;

	if(confirm($.l10n.__('DiskManager_alert_toformat'))){
		if(confirm($.l10n.__('DiskManager_alert_data_lost'))){	
			$("#waiting").show();
			var p=$("div.selected",window.$PARTITIONS)[0];
			var path=p.data.path.indexOf('freespace')===0?p.data.device.data.path:p.data.path;
			$.ajax({
				url: window.top.remoteDataUrl+"nas/format/partition"
				,cache:false
				,data:{
					hash:window.top.SessionID
					,path:path
					,fs:$("#fslist").val()
					,label:$("#volumelabel").val()
				}
				,type: "POST"
				,dataType:"xml"
				,success: function(data){
					$("#waiting").hide();
					if(window.top.checkAPIError(data))return; 
					window.top.DiskManager.showFormat({path:path,win:window});
					//alert($('mkfs',data).text());
				}
				,error:function(data){
					$("#waiting").hide();
					alert ( $.l10n.__("global_alert_getdataerror") );
				}
				//,timeout:20000
				
			});
			}
	}
}


function mountPartition(){
	if(!toValidateMount())return;
	$("#waiting").show();
	var p=$("a.selected",window.$TREE)[0];
	$.ajax({
		url: window.top.remoteDataUrl+"nas/mount/partition"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,path:p.data.path
			,mountpoint: $("#mountpoint").val()
			,static:(p.data.fs=='swap'||p.data.device.data.connectiontype=='ata'||$(p.data.device).hasClass('raiddevice')||$("#mountpoint").val()=='home')?'yes':'no'
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return; 
			if( $("#mountpoint").val()=='home' )window.top.loadNASinfo();
			loadData();
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
		//,timeout:20000
	});
}


function unmountPartition(){
	if(!$("#UNMOUNT").hasClass('enabled'))return;
	var p=$("a.selected",window.$TREE)[0];
	p.data.mountpoint.each(function(){
		$("#waiting").show();
		var mountpoint=$(this).text();
		$.ajax({
			url: window.top.remoteDataUrl+"nas/umount/partition"
			,cache:false
			,data:{
				hash:window.top.SessionID
				,path:p.data.path
				,mountpoint:mountpoint
				,static:'yes'
			}
			,type: "POST"
			,dataType:"xml"
			,success: function(data){
				$("#waiting").hide();
				if(window.top.checkAPIError(data))return; 
				loadData();
				window.top.loadNASinfo();
			}
			,error:function(data){
				$("#waiting").hide();
				alert ( $.l10n.__("global_alert_getdataerror") );
			}
			//,timeout:20000
			
		});
	});
}


function clearRaid(){
	$('tr',window.grid).remove();	
}


function addPartitionToRaidList(p){
	if(typeof(p)==='object'){
		var $p=$(p);	
//??		if($p.hasClass('raidmember')||$p.hasClass('raidpart')||$p.hasClass('raiddevice') || $p.hasClass('mounted') || ( $p.hasClass('device')&&$p.hasClass('hasmounted') )){
		if($p.hasClass('raidlive')|| $p.hasClass('raidpart') || $p.hasClass('hasraidpart')|| $p.hasClass('raiddevice') || $p.hasClass('mounted') || $p.hasClass('hasmounted') || p.data.connectiontype==='usb' || (p.data.device&&p.data.device.data.connectiontype==='usb')){

			alert($.l10n.__('DiskManager_alert_raid_israided'));
			return;
		}
		if($('tr#'+p.data.path.replace(/\//g,''), window.grid).length>0 ){
			alert($.l10n.__('DiskManager_alert_raid_partitionexist'));
			return;
		}
		if( p.data.device  && $('tr#'+p.data.device.data.path.replace(/\//g,''), window.grid).length>0){
			return;
		}
		var $trs=$('tr',window.grid)
		var path=p.data.path;
		for(var i=0,l=$trs.length;i<l;i++){
			if($trs[i].getData().Path.indexOf(path)===0)return;
		}
	}else{
		var $p=$("a[path="+p+"]",window.$TREE);  
		if($p.length>0)p=$p[0]; 
	}
	
	if(typeof(p)==='object'){
		window.grid.grid.addRow({
			id:p.data.path.replace(/\//g,'')
			,Delete:"<a class='icon s12 remove' path='"+p.data.path+"'></a>"
			,Path:p.data.path
			,Size:p.data.size+'('+formatBytes(p.data.size)+')'
		});
	}
	else{
		window.grid.grid.addRow({
			id:p.replace(/\//g,'')
			,Delete:"<a class='icon s12 remove' path='"+p+"'></a>"
			,Path:p
			,Size:''
		});
	}
	$("tr:last a.icon",window.grid).click(function(){
		var $d=$('a.selected',window.$TREE);
		if($d.hasClass('raiddevice')){
			var d=$d[0]; 
			var l=$('level',d.data.raid).text();
			var ds=$('raiddevice',d.data.raid);
			var rd=[];
			for(var i=0,ii=ds.length; i<ii; i++){
				rd.push($(ds[i]).text());
			}
			//raid4 5 6 10 ------
			if(l==='raid1'){
				if($.inArray($(this).attr('path'),rd)<0){$(this.parentNode.parentNode.parentNode).remove(); return;}
				if(confirm( $.l10n.__('DiskManager_alert_removeraidmember') ) ){
					$('#waiting').show();
					$.ajax({
						url: window.top.remoteDataUrl+"nas/remove/raid"
						,cache:false
						,data:{
							hash:window.top.SessionID
							,device:d.data.path
							,path:$(this).attr('path').split(' ')[0]
						}
						,type: "POST"
						,dataType:"xml"
						,success: function(data){
							$('#waiting').hide();
							if(window.top.checkAPIError(data))return; 
							loadData();
						}
						,error:function(data){
							$("#waiting").hide();
							alert ( $.l10n.__("global_alert_getdataerror") );
						}
						//,timeout:20000
						
					});
				}				
			}
		}
		else{
			$(this.parentNode.parentNode.parentNode).remove();
		}
	});
}


function createRaid(){
	if(!toValidateRaid())return;
	if(confirm($.l10n.__('DiskManager_alert_raid_tocreate'))){
		if(confirm($.l10n.__('DiskManager_alert_data_lost'))){	
			var disks="";
			$("tr",window.grid).each(function(){
				disks +="&disks="+this.getData().Path
			});
			$("#waiting").show();
			$.ajax({
				url: window.top.remoteDataUrl+"nas/create/raid"
				,cache:false
				,data:'hash='+window.top.SessionID
					+'&level='+$("#raidtypelist").val()
					+'&device=home'
					+'&force=yes'
					+disks
				,type: "POST"
				,dataType:"xml"
				,success: function(data){
					$("#waiting").hide();
					if(window.top.checkAPIError(data))return;
					loadData();
				}
				,error:function(data){
					$("#waiting").hide();
				}
				//,timeout:20000
				
			});
		}
	}
}



function destroyRaid(){
	if(confirm($.l10n.__('DiskManager_alert_raid_todestroy'))){
		if(confirm($.l10n.__('DiskManager_alert_data_lost'))){
			var p=$("a.selected",window.$TREE)[0];
			$("#waiting").show();
			$.ajax({
				url: window.top.remoteDataUrl+"nas/destroy/raid"
				,cache:false
				,data:{
					hash:window.top.SessionID
					,device:p.data.path
				}
				,type: "POST"
				,dataType:"xml"
				,success: function(data){
					$("#waiting").hide();
					if(window.top.checkAPIError(data))return;
					loadData();
				}
				,error:function(data){
					$("#waiting").hide();
					alert ( $.l10n.__("global_alert_getdataerror") );
				}
				//,timeout:20000
				
			});
		}
	}
}


function rebuildRaid(){
	var d=$('a.selected',window.$TREE)[0];
	var ds=$('raiddevice',d.data.raid);
	var rd=[];
	for(var i=0,ii=ds.length; i<ii; i++){
		rd.push($(ds[i]).text());
	}
	$("tr",window.grid).each(function(){
		var path=this.getData().Path;
		var path0=path.split(' ')[0];
		if($.inArray(path,rd)<0||$.inArray(path0,rd)<0){
			$("#waiting").show();
			$.ajax({
				url: window.top.remoteDataUrl+"nas/add/raid"
				,cache:false
				,data:{
					hash:window.top.SessionID
					,device:d.data.path
					,path:this.getData().Path.split(' ')[0]
				}
				,type: "POST"
				,dataType:"xml"
				,success: function(data){
					$("#waiting").hide();
					if(window.top.checkAPIError(data))return;
					loadData();
				}
				,error:function(data){
					$("#waiting").hide();
				}
				//,timeout:20000				
			});
		}	
	});
}


function detectRaid(){
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/active/raid"
		,cache:false
		,data:{hash:window.top.SessionID}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			//if(window.top.checkAPIError(data))return;
			if($('nas error',data).length>0){
				alert('No RAID found!');
			}
			loadData();
		}
		,error:function(data){
			$("#waiting").hide();
		}
		//,timeout:20000
	});
}


function showSmart(){
	if(!$("#SMART").hasClass('enabled'))return;
	var p=$("a.selected",window.$TREE)[0];
	window.top.DiskManager.showSmart(p.data.path);
}


function toValidateRaid(){
	var trs=$("tr",window.grid).length;
	var rt=$("#raidtypelist").val();
	if((rt=="linear"||rt=="0"||rt=="1")&&trs<2){
		alert($.l10n.__('DiskManager_alert_leastnum').replace('{0}',2));
		return false;
	}
	if((rt=="4"||rt=="5")&&trs<4){
		alert($.l10n.__('DiskManager_alert_leastnum').replace('{0}',3));
		return false;
	}
	if((rt=="6"||rt=="10")&&trs<5){
		alert($.l10n.__('DiskManager_alert_leastnum').replace('{0}',4));
		return false;
	}
	return true;
}


function toValidateMount(){
	var $n=$("a.mounted",window.$TREE);
	for(var i=0;i<$n.length;i++){
		var ary=$n[i].data.mountpointtext.split(','); 
		if( $.inArray($('#mountpoint').val(),ary)>-1&&$('#mountpoint').val()!==''){
			alert($.l10n.__('DiskManager_alert_mountpointinuse').replace('{0}', $('#mountpoint').val()));
			return false;
		}
	};
	var a=$('a.selected',window.$TREE)[0]; 
	if(a.data.fs!=='swap'){
		var fields = [
		{
			method : 'regex',
			value : $('#mountpoint').val(), 
			element : $('#mountpoint')[0],
			param : '^[a-zA-Z0-9_]{1,16}$', 
			errParam : $.l10n.__('DiskManager_text_mountpoint')
		}
		];
		fields .push({
			method : 'required',
			value : $('#mountpoint').val(), 
			element : $('#mountpoint')[0],
			param : null, 
			errParam : $.l10n.__('DiskManager_text_mountpoint')
		});
		return validateFields(fields);
	}
	return true;
}

function toValidateFormat(){
	//if(window.noswap&&$('#fslist').val()!=='swap'){
		//if( ! confirm($.l10n.__('DiskManager_text_noswap')) )return;
	//}
	var fields = [
		{
			method : 'regex',
			value : $('#volumelabel').val(), 
			element : $('#volumelabel')[0],
			param : '^[a-zA-Z0-9_]{0,16}$', 
			errParam : $.l10n.__('DiskManager_text_label')
		}
	];
	return validateFields(fields);	
}


function toCalculatePartition(){
	var $this=$("#partitionsize");
	var t=$this[0];
	var v=$this.val();
	
	if(/^\d+(\.\d+){0,1}\%/.test(v)){
		v=v.replace('%','')-0;
		if(v>100)v=100;
		v=v/100*t.data.length*t.data.sectorsize;
		$this.val( formatBytesNumber(v,2) );
	}else{
		if(isNaN(v))$("#partitionsize").val( formatBytesNumber(t.data.length*t.data.sectorsize,2) );
		else if(v*1024*1024-0>t.data.length*t.data.sectorsize) $("#partitionsize").val( formatBytesNumber(t.data.length*t.data.sectorsize,2) );
	}

	$('#partitions div.selected').css({height:   ( $this.val()*1024*1024/t.data.sectorsize/t.data.devicelength  *100)+'%'      });
	$('#partitions div.selected')[0].data.curlength= parseInt( $this.val()*1024*1024/t.data.sectorsize);
}


function showOption(){
	window.top.DiskManager.showOption();
}

function sortNumber(a,b){
	return a - b
}