﻿$(function(){
	window.App="DiskManager";
	layout();
	loadLang();
	bindEvent();
	loadData();
});




function bindEvent(){
	$("#AUTO1").click(autoInternal);
	$("#AUTO2").click(autoExternal);
	$("#OPTION1,#OPTION2").click(showOption);
	$("#REFRESH1,#REFRESH2").click(loadData);	
}


function layout(){
	$("#inernallist").flexigrid({
		singleSelect:false
		,colModel : [
				{display: '', name : 'selection', width : 30, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="DiskManager_text_Dpath"></label>', name : 'path', width : 100, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="DiskManager_text_Dlength"></label>', name : 'size', width : 120, sortable : false, align: 'right'}
				,{display: '<label domain="l10n" msgid="DiskManager_text_Dmodel"></label>', name : 'model', width : 200, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="DiskManager_text_Dserial"></label>', name : 'serial', width : 200, sortable : false, align: 'left'}
				]
	});
	$("#externallist").flexigrid({
		singleSelect:true
		,colModel : [
				{display: '', name : 'selection', width : 30, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="DiskManager_text_Dpath"></label>', name : 'path', width : 100, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="DiskManager_text_Dlength"></label>', name : 'size', width : 120, sortable : false, align: 'right'}
				,{display: '<label domain="l10n" msgid="DiskManager_text_Dmodel"></label>', name : 'model', width : 200, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="DiskManager_text_Dserial"></label>', name : 'serial', width : 200, sortable : false, align: 'left'}
				]
	});
	$("ul.tabs a:first").click(function(){	$("#inernallist")[0].grid.Resize();	});
	$("ul.tabs a:last").click(function(){	$("#externallist")[0].grid.Resize();	});
	

}

function showOption(){
	window.top.DiskManager.showOption();
}

function loadData(){
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/devices"
		,cache:false
		,data:{
			hash:window.top.SessionID
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
		//,timeout:20000
		
	});
}


function parseData(data){
	$('#inernallist,#externallist').empty();
	$('device',data).each(function(){
		if($('length:first',this).text()!=='0' && $('model',this).text()!=='Linux Soft RAID'){
			var d={		
				path:$(this).children('path').text()
				,serial:$(this).children('serial').text()
				,model:$(this).children('model').text()
				,connectiontype:$(this).children('connectiontype').text()
				,cylinder:$(this).children('cylinder').text()-0
				,head:$(this).children('head').text()-0
				,sector:$(this).children('sector').text()-0
				,length:$(this).children('length').text()-0
				,sectorsize:$(this).children('sectorsize').text()-0
				,partitions:$(this).children('partition')
				,raid:$(this).children('raid')
				,raidmember:$(this).children('raidmember').text()
				,type:$(this).children('type').text()
			};
			d.size=d.length*d.sectorsize;

			if(d.connectiontype==='usb'){
				$('#externallist')[0].grid.addRow({
					id:d.path
					,selection:'<span class="checkbox"/></span>'
					,path:d.path
					,size:formatBytes(d.size)
					,serial:d.serial
					,model:d.model
				});
			
			}else{
				$('#inernallist')[0].grid.addRow({
					id:d.path
					,selection:'<span class="checkbox"/></span>'
					,path:d.path
					,size:formatBytes(d.size)
					,serial:d.serial
					,model:d.model
				});
				
				$("#inernallist tr:last").click(function(){
					var $s=$('#inernallist tr.trSelected');
					// 1: single    2 2*n:  RAID1            >=3 RAID5       4 2*n  RAID10          >=4  RAID6   
					$("#mode1").empty();
					var l=$s.length;
					if(l===1){	//single
						$("#mode1").html('<option value="-1">Single Harddisk</option>');
					}
					else{
						$("#mode1").html('<option value="linear">LINEAR(BIG)</option><option value="0">RAID 0(Striping)</option>');
						if(l>=3){ //RAID5
							$("#mode1").append('<option value="5">RAID 5</option>');
						}
						if(l>=4){ //RAID6
							$("#mode1").append('<option value="6">RAID 6</option>');
						}
						if(l%2===0){  //RAID1
							$("#mode1").append('<option value="1">RAID 1(Mirroring)</option>');
						}
						if(l>=4&&l%2===0){ //RAID10
							$("#mode1").append('<option value="10">RAID 10</option>');
						}
					}
				});
			}
		}
	});
}

function autoInternal(){
	var $s=$('#inernallist tr.trSelected');
	if($s.length===0)return;
	var path=[];
	$s.each(function(){ path.push(this.id); });
	path=path.join(',');
	var mode=$('#mode1').val();
	var fs=$('#fs1').val();
	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/storage/allinone"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,level:mode
			,fs:fs
			,isinternal:'yes'
			,disks:path
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			window.top.loadNASinfo();
			alert('Completed!');
		}
		,error:function(data){
			$("#waiting").hide();
		}
		//,timeout:20000
		
	});	
}

function autoExternal(){
	var $s=$('#externallist tr.trSelected');
	if($s.length===0)return;
	var path=$s.attr('id');
	var fs=$('#fs2').val();
	
	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/storage/allinone"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,fs:fs
			,isinternal:'no'
			,disks:path
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			window.top.loadNASinfo();
			alert('Completed!');
		}
		,error:function(data){
			$("#waiting").hide();
		}
		//,timeout:20000
		
	});		
}