﻿$(function(){
	window.App="Downloader";
	layout();
	loadUI();
	loadLang();
});

function bindEvent(){
	$("#ADD").click(toAdd);
	$("#UPLOAD").click(toUpload);
	$("#CLEAR").click(toClear);
	$("#START").click(toStart);
	$("#PAUSE").click(toPause);
	$("#INFO").click(toInfo);
	$("#REFRESH").click(function(){ loadData($("#list ul a.selected")[0].id);	});
	$("#DIR").click(toDir);
	$("#SEEDDIR").click(toSeedDir);
	$("#list ul a").click(function(){	loadData(this.id);	});
	$('#all').click();
}

function loadData(option){
		option=(option=="all")?"":option;
		$("#waiting").show();
		$.ajax({
		   url: window.top.remoteDataUrl + 'nas/proxy/get'
		   ,data:{
				hash:window.top.SessionID	
				,httpurl: 'http://127.0.0.1:4080/submit?q=vd+' + option
		   }
		   ,type: "GET"
		   ,cache:false
		   ,dataType: "text"
		   ,success: function(data){
				$("#waiting").hide();
				showData(data);
			}
		   ,error: function(data) {
				$("#waiting").hide();
				alert($.l10n.__('Downloader_alert_noservice'));
			}
		   //,timeout: 10000
		 });
}


function layout(){
	window.Layout = $('body').layout({ 
			center__paneSelector:"#main" 
		,	north__paneSelector:"#top" 
		,	north__size:60
		,	north__spacing_open:0
		,	west__paneSelector:"#left" 
		,	west__size:200
		,	west__spacing_open:5
		,	contentSelector:".data"	
		,	center__onresize_end:function(){
				$(window).resize();
			}
	}); 

	$("#main").html('<table/>');
	window.grid=$("#main table:first")[0];
	
	$('#toolbar').toolbar();
	$("#list").treeview();
}

function loadUI(){
	$.ajax({
		url:window.top.root+'downloads/.ui.conf'
		,data:{
			hash:window.top.SessionID
		}
		,dataType:'json'
		,success:function(json){initTable(json);}
		,error:function(){initTable();}
	});
}

function saveUI(json){
	var j=JSON.stringify(json);
	var options = {
			content: j
			,content_type:  'text/json'                   
	};
	window.top.webdav.PUT({}, window.top.root+'downloads/.ui.conf', options);
}


function initTable(json){
	var labels={
		'S':'<label domain="l10n" msgid="Downloader_text_status"></label>'
		,'N':'<label domain="l10n" msgid="Downloader_text_network"></label>'
		,'File':'<label domain="l10n" msgid="Downloader_text_file"></label>'
		,'Size':'<label domain="l10n" msgid="Downloader_text_size"></label>'
		,'Percentage':'<label domain="l10n" msgid="Downloader_text_progress"></label>'
		,'DLed':'<label domain="l10n" msgid="Downloader_text_dowloaded"></label>'
		,'Cm':'<label domain="l10n" msgid="Downloader_text_comments"></label>'
		,'Src':'<label domain="l10n" msgid="Downloader_text_sources"></label>'
		,'A':'<label domain="l10n" msgid="Downloader_text_active"></label>'
		,'Avail':'<label domain="l10n" msgid="Downloader_text_avail"></label>'
		,'Age':'<label domain="l10n" msgid="Downloader_text_age"></label>'
		,'Last':'<label domain="l10n" msgid="Downloader_text_last"></label>'
		,'Rate':'<label domain="l10n" msgid="Downloader_text_rate"></label>'
		,'ETA':'<label domain="l10n" msgid="Downloader_text_ETA"></label>'
		,'Priority':'<label domain="l10n" msgid="Downloader_text_priority"></label>'
	};
	var P=['S','N','File','Size','Percentage','DLed','Cm','Src','A','Avail','Age','Avail','Age','Last','Rate','Rate','ETA','Priority'];
	var JS={
			table:{
				'S':{width:24,hide:false}
				,'N':{width:60,hide:true}
				,'File':{width:150,hide:false}
				,'Size':{width:50,hide:false}
				,'Percentage':{width:100,hide:false}
				,'DLed':{width:60,hide:false}
				,'Cm':{width:60,hide:true}
				,'Src':{width:60,hide:true}
				,'A':{width:60,hide:false}
				,'Avail':{width:60,hide:true}
				,'Age':{width:60,hide:true}
				,'Last':{width:60,hide:true}
				,'Rate':{width:60,hide:false}
				,'ETA':{width:60,hide:true}
				,'Priority':{width:60,hide:true}
			}
		};
	if(!json||!json.table){
		json=JS;
	}
	var colModel=[];
	for(var m=0,l=P.length;m<l;m++){
		var i=P[m];
		var j=json.table[i];
		if(!j)j=JS.table[i];
		if(!j.width||typeof(j.width)!=='number'||(typeof(j.width)==='number')&&j.width<10){j.width=JS.table[i].width;}
		if(!j.hide||typeof(j.hide)!=='boolean'){j.hide=JS.table[i].hide;}
		colModel.push({display: labels[i], name : i, width : j.width, sortable : false, align: 'left',hide:j.hide});
	}
	$(window.grid).flexigrid({
		singleSelect:false
		,colModel : colModel
		,saveUI: saveUI
	}); 
	window.setLang({app:window.App,el:$("#main")}); 
	bindEvent();
}

function showData(data){
	$('tr',window.grid).remove();
	if($("#temp").length==0)$("body").append('<div id="temp" style="display:none;"></div>');
	$("#temp").html(data);	
	
	 var table=($("#temp table.downloaders:first"));
	 $("tr:first, table",table).remove();
	 $(table.children(0).children()).each(function(){ 
		 var id=$("input:checkbox:first",this).val(); 
		 var tds=$(">td",this);
		 var S=tds[0].innerHTML; 
		 var Status=(S=="P")?"paused":"";
		 S=(S=="P")?'<a class="icon s12 downloadstop"></a>':'<a class="icon s12 download"></a>';
		 //var R=tds[1].innerHTML; 
		 //var C=tds[2].innerHTML; 
		 //var R2=tds[3].innerHTML; 
		 var N=tds[4].innerHTML; 
		 var File=tds[5].innerHTML; 
		 var Size=tds[6].innerHTML; 
		 var Dowloaded=tds[7].innerHTML; 
		 var Percentage=tds[8].innerHTML+"%"; Percentage="<div class='progressbar' style='padding:0;margin:0;width:100%;'><div style='padding:0;margin:0;width:"+Percentage+"'></div><span>"+Percentage+"</span></div>";
		 var Cm=tds[9].innerHTML; 
		 var Src=tds[10].innerHTML; 
		 var A=tds[11].innerHTML; 
		 var Avail=tds[12].innerHTML; 
		 var Age=tds[13].innerHTML; 
		 var Last=tds[14].innerHTML; 
		 var Rate=tds[15].innerHTML; 
		 var ETA=tds[16].innerHTML; 
		 var Priority=tds[17].innerHTML; 
		window.grid.grid.addRow({
				id:id
				,S:S
				//,R:R
				//,C:C 
				//,R2:R2
				,N:N
				,File:File
				,Size:Size
				,Percentage:Percentage
				,DLed:Dowloaded
				//,Percentage:Percentage
				,Cm:Cm
				,Src:Src
				,A:A
				,Avail:Avail
				,Age:Age
				,Last:Last
				,Rate:Rate
				,ETA:ETA
				,Priority:Priority
		});
		
		$('tr:last',window.grid).addClass(Status); 
		
	});
	$("#temp").remove();
	enableTools(); 
	$('tr',window.grid).click(function(){ 
		itemEvent();
	}).dblclick(function(){		
		$("tr",window.grid).removeClass('trSelected');
		$(this).click();
		$("#INFO").click();
	});
	$('select',window.grid).change(function(){ 
		toSetPriority(this);
	});

} 

function enableTools(){
	$("#DOWNLOADER li").removeClass('enabled');
	$("#ADD, #REFRESH, #UPLOAD, #DIR, #SEEDDIR").addClass("enabled");
}

function itemEvent(){
	var trs=$("tr.trSelected",window.grid); 
		if(trs.length>0){
			$("#CLEAR").addClass('enabled'); 
			if(trs.length==1){
				$("#INFO").addClass('enabled');
				if( trs.hasClass('paused') ){
					$("#START").addClass('enabled');
					$("#PAUSE").removeClass('enabled');
				}
				else{
					$("#START").removeClass('enabled');
					$("#PAUSE").addClass('enabled');
				}
			}
			else{
				$("#INFO").removeClass('enabled');
				$("#START").addClass('enabled');
				$("#PAUSE").addClass('enabled');
			}
		}
		else{
			enableTools();
		}
}


function toAdd(){
	if(!$("#ADD").hasClass('enabled'))return;
	var name=prompt($.l10n.__("Downloder_text_downloadurl"),"");
	if(name==null||name.replace(/\s/g,"")=="")return;
	$.ajax({
		url: window.top.remoteDataUrl + 'nas/proxy/get'
		,data:{
			hash:window.top.SessionID	
			,httpurl: 'http://127.0.0.1:4080/submit?jvcmd=multidllink&links=' + encodeURIComponent(name)
		}
		,type: "GET"
		,dataType: "text"
		,success: function(data){
			$("#waiting").hide();
			$("#REFRESH").click();
		}
		,error: function(data) {
			$("#waiting").hide();
		}
	});
}



function toClear(){
	if(!$("#CLEAR").hasClass('enabled'))return;
	var trs=window.grid.grid.getSelectedRows();
	var s=[];
	for(var i=0;i<trs.length;i++){
		s.push( "cancel="+trs[i].id );
	}
	s=s.join('&');
	$.ajax({
		url: window.top.remoteDataUrl + 'nas/proxy/get'
		,data:{
			hash:window.top.SessionID	
			,httpurl: 'http://127.0.0.1:4080/files?' + s
		}
	   ,cache:false
	   ,type: "GET"
	   ,dataType: "text"
	   ,success: function(data){
			$("#waiting").hide();
			$("#REFRESH").click();
		}
	   ,error: function(data) {
			$("#waiting").hide();
		}
	   //,timeout: 10000
	});
}


function toStart(){
	if(!$("#START").hasClass('enabled'))return;
	var trs=window.grid.grid.getSelectedRows();
	var s=[];
	for(var i=0;i<trs.length;i++){
		s.push( "resume="+trs[i].id );
	}
	s=s.join('&');
	$.ajax({
		url: window.top.remoteDataUrl + 'nas/proxy/get'
		,data:{
			hash:window.top.SessionID	
			,httpurl: 'http://127.0.0.1:4080/files?' + s
		}
	   ,cache:false
	   ,type: "GET"
	   ,dataType: "text"
	   ,success: function(data){
			$("#waiting").hide();
			$("#REFRESH").click();
		}
	   ,error: function(data) {
			$("#waiting").hide();
		}
	   //,timeout: 10000
	});
}

function toPause(){
	if(!$("#PAUSE").hasClass('enabled'))return; 
	var trs=window.grid.grid.getSelectedRows();
	var s=[]; 
	for(var i=0;i<trs.length;i++){
		s.push( "pause="+trs[i].id );
	}
	s=s.join('&');
	$.ajax({
		url: window.top.remoteDataUrl + 'nas/proxy/get'
		,data:{
			hash:window.top.SessionID	
			,httpurl: 'http://127.0.0.1:4080/files?' + s
		}
	   ,cache:false
	   ,type: "GET"
	   ,dataType: "text"
	   ,success: function(data){
			$("#waiting").hide();
			$("#REFRESH").click();
		}
	   ,error: function(data) {
			$("#waiting").hide();
		}
	   //,timeout: 10000
	});
}


function toSetPriority(s){
	$.ajax({
		url: window.top.remoteDataUrl + 'nas/proxy/get'
		,data:{
			hash:window.top.SessionID	
			,httpurl: 'http://127.0.0.1:4080/submit?q=priority+'+s.value+"+"+s.id.replace('selectPriority','')
		}
	   ,type: "GET"
	   ,dataType: "text"
	   ,cache:false
	   ,success: function(data){
			$("#waiting").hide();
			$("#REFRESH").click();
		}
	   ,error: function(data) {
			$("#waiting").hide();
		}
	   //,timeout: 10000
	});
}


function toInfo(){
	if(!$("#INFO").hasClass('enabled'))return;
	var trs=window.grid.grid.getSelectedRows();
	window.top.Downloader.Info(trs[0].id);
}

function toUpload(){
	if(!$("#UPLOAD").hasClass('enabled'))return;
	window.top.System.toUpload(window.top.root+'downloads/torrents/incoming/');
}


function toDir(){
	window.top.System.viewDir(window.top.root+'downloads/incoming/');
}


function toSeedDir(){
	window.top.System.viewDir(window.top.root+'downloads/torrents/seeded/');
}