﻿$(function(){
	window.App="Monitoring";
	window.app=window.top[window.App];
	bindEvent();
	layout();
	loadLang();
});

function layout(){
	$('body').layout({ 
			center__paneSelector:"#main"
		,	north__paneSelector:"#top"  
		,	north__size:24
		,	north__spacing_open:0
		,	south__paneSelector:"#bottom"  
		,	south__size:80
		,	south__spacing_open:0
		,	contentSelector:".data"
		,	center__onresize_end:function(){ window.setTimeout(function(){window.chart.setSize($('#chart').width(),$('#chart').height());},288); }
	}); 
	$('#Tag1').layout({ 
			center__paneSelector:"#chart"
		,	south__paneSelector:"#table"  
		,	south__size:180
		,	south__spacing_open:0
		,	contentSelector:".data"
	}); 
	$('.tabs a').click(function(){$(window).resize();});
	window.grid=$("#process")[0];
	$("#process").flexigrid({
		singleSelect:true
		,colModel : [
			{display: 'PID', name : 'PID', width : 60, sortable : false, align: 'left'}
			,{display: 'USER', name : 'USER', width : 60, sortable : false, align: 'left'}
			,{display: 'PR', name : 'PR', width : 40, sortable : false, align: 'left',hide:true}
			,{display: 'NI', name : 'NI', width : 40, sortable : false, align: 'left',hide:true}
			,{display: 'VIRT', name : 'VIRT', width : 60, sortable : false, align: 'left',hide:true}
			,{display: 'RES', name : 'RES', width : 60, sortable : false, align: 'left',hide:true}
			,{display: 'SHR', name : 'SHR', width : 60, sortable : false, align: 'left',hide:true}
			,{display: 'S', name : 'S', width : 40, sortable : false, align: 'left',hide:true}
			,{display: 'CPU', name : 'CPU', width : 60, sortable : false, align: 'left'}
			,{display: 'MEM', name : 'MEM', width : 60, sortable : false, align: 'left'}
			,{display: 'TIME', name : 'TIME', width : 80, sortable : false, align: 'left',hide:true}
			,{display: 'COMMAND', name : 'COMMAND', width : 150, sortable : false, align: 'left'}
		]
	});
	$('#chart').highcharts({
		width:'100%'
		,height:'100%'
		,credits:{
			enabled:false
		}
		,title: {
			text: '',
			x: -20 
		}
		,legend:false
		,chart: {
			type: 'line'
			,background:'#000'
			,marginRight: 25
			,marginBottom: 25
		}
		,xAxis: {
			type: 'datetime',
			tickInterval: 5000, 
			tickWidth: 0,
			gridLineWidth: 1,
			labels: false
		}
		,yAxis: {
			max:100
			,min:0
			,gridLineWidth: 1
			,tickInterval:10
			,title: false
			,plotLines: [{
				value: 0,
				width: 1,
				color: '#808080'
			}]
		}
		,tooltip: {
			valueSuffix: '%'
		}
		,series: [{
			name: 'CPU',
			color:'#69BD45',
			data: [null,null,null,null,null,null,null,null,null,null]
		},{
			name: 'MEM',
			color:'#F59220',
			data: [null,null,null,null,null,null,null,null,null,null]
		}]
        }); 
	window.chart=$('#chart').highcharts();
	$('#START').click();
}


function bindEvent(){
	$('#START').click(function(){
		//if(window.interval)window.clearInterval(window.interval);
		//window.interval=window.setInterval(loadData,3000);
		window.run=true;
		$('#START').hide();
		$('#STOP').show();
		loadData();
	});
	$('#STOP').click(function(){
		//if(window.interval)window.clearInterval(window.interval);
		window.run=false;
		$('#START').show();
		$('#STOP').hide();
	});
	$('#REFRESH').click(function(){
		if(!window.chart)return;
		$('#waiting').show();
		window.chart.series[0].setData([null,null,null,null,null,null,null,null,null,null]);
		window.chart.series[1].setData([null,null,null,null,null,null,null,null,null,null]);
		$('#START').click();
	});
}

function loadData(){
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/monitor/"
		,cache:false
		,type: "POST"
		,data: {
			hash:window.top.SessionID
		}
		,dataType: "xml"
		,success: function(data){
			if(window.top.checkAPIError(data))return;	
			parseData(data);
		}
		,error: function(data) { 			   
			$('#waiting').hide();
			//alert ( $.l10n.__("global_alert_getdataerror") );
		}
		//timeout:20000
	});
}


function parseData(data){
	$('#waiting').hide();
	if(!window.run)return;
	$(window.grid).empty();
	var top=$('top',data).text();
	var t=top.split('\n');
	for(var i=7;i<t.length;i++){
		var r=t[i].split(' ');
		var p=[];
		for(var j=0;j<r.length;j++){
			if(r[j]!=='')p.push(r[j]);
		}
		if(p.length===0)continue;
		var p11=[];
		for(j=11;j<p.length;j++){
			p11.push(p[j]);
		}
		window.grid.grid.addRow({
			id:p[0]
			,PID:p[0]
			,USER:p[1]
			,PR:p[2]
			,NI:p[3]
			,VIRT:p[4]
			,RES:p[5]
			,SHR:p[6]
			,S:p[7]
			,CPU:p[8]
			,MEM:p[9]
			,TIME:p[10]
			,COMMAND:p11.join(' ')
		});
	}
	
	
/*
top - 12:58:26 up  3:47,  2 users,  load average: 0.07, 0.10, 0.06
Tasks: 127 total,   1 running, 126 sleeping,   0 stopped,   0 zombie
Cpu(s):  0.2%us,  0.1%sy,  0.1%ni, 99.4%id,  0.3%wa,  0.0%hi,  0.0%si,  0.0%st
Mem:   1007776k total,   639608k used,   368168k free,    14516k buffers
Swap:        0k total,        0k used,        0k free,   220972k cached
*/
	var time=getValue(' up',t[0]);
	
	var av=t[0].split('load average: ')[1];
	av=av.replace(/\s/g,'').split(',');
	$('#av1').html(av[0]);
	$('#av5').html(av[1]);
	$('#av15').html(av[2]);
	
	var us=getValue('us',t[2]);
	var sy=getValue('sy',t[2]);
	var ni=getValue('ni',t[2]);
	var id=getValue('id',t[2]);
	var wa=getValue('wa',t[2]);
	$('#us').html(us);
	$('#sy').html(sy);
	$('#ni').html(ni);
	$('#id').html(id);
	$('#wa').html(wa);	
	
	var mtotal=getValue(' total',t[3]);
	var mused=getValue(' used',t[3]);
	var mfree=getValue(' free',t[3]);
	var mbuffers=getValue(' buffers',t[3]);
	$('#mtotal').html(mtotal);
	$('#mused').html(mused);
	$('#mbuffers').html(mbuffers);
	$('#mfree').html(mfree);
	
	var stotal=getValue(' total',t[4]);
	var sused=getValue(' used',t[4]);
	var sfree=getValue(' free',t[4]);
	var scached=getValue(' cached',t[4]);
	$('#stotal').html(stotal);
	$('#sused').html(sused);
	$('#scached').html(scached);
	$('#sfree').html(sfree);
	
	
	var speed=$('speed',data).text();
	var temp=$('temp',data).text();
	if(speed!=''&&temp!==''){
		$('.other').show();
		$('#temp').html(temp+'°C');
		$('#speed').html(speed==='0'?'Off':'On');
	}else{
		$('#temp,#speed').empty();
		$('.other').hide();
	}
	var cp=round(100-id.replace('%',''),2);
	var mp=round((parseInt(mused)+parseInt(sused))/(parseInt(mtotal)+parseInt(stotal))*100,2);
    	$('#cpubar div').css({height:id});
    	$('#membar div').css({height:(100-mp)+'%'});
	$('#cpupercent').html(cp+'%');
	$('#mempercent').html(mp+'%');
	var s1=window.chart.series[0].data;
	var s2=window.chart.series[1].data;
	var shift1 = s1.length > 10; 
	var shift2 = s2.length > 10; 
	chart.series[0].addPoint([time, cp], true, shift1);
	chart.series[1].addPoint([time, mp], true, shift1);
	if(window.run)loadData();
}

function getValue(n,t){
	var r=t.split(n)[0];
	r=r.split(' ');
	r=r[r.length-1];
	return r;
}