﻿$(function(){
	window.App="Preference";
	loadLang();	
	bindEvent();
	loadData();
});



//-----------------------------------------------------------------------------------------------------------------------
function bindEvent(){	
	$("#APPLY").click(toApply);
	$("#RESCAN").click(rescan);
	$("#check").click(enableService);	
	$("#browse").click(showBrowse);	
	$("#REFRESH").click(loadData);
}



//-----------------------------------------------------------------------------------------------------------------------
function loadData(){	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/dlna"
		,cache:false
		,data:{
			hash:window.top.SessionID
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}



function parseData(data){
	if($('enable',data).text().toLowerCase()=='yes'){
		$("#check").attr('checked','checked');
	}else{
		$("#check").removeAttr('checked');
	}
	if($('running',data).text().toLowerCase()=='yes'){
		$('#running').html('<label domain="l10n" msgid="Preference_main_text_servicerunning">'+$.l10n.__('Preference_main_text_servicerunning')+'</label>');
		$('#RESCAN').show();
	}else{
		$('#running').html('<label domain="l10n" msgid="Preference_main_text_servicestopped">'+$.l10n.__('Preference_main_text_servicestopped')+'</label>');
		$('#RESCAN').hide();
	}
	
	if($('version',data).text().indexOf('Version minidlna-IODATA-')===0){
		$('#tr_albumsize').show();
		switch($('album_art_size',data).text()){
			case "160":
				$('#albumsize')[0].selectedIndex=0;
			break;
			case "500":
				$('#albumsize')[0].selectedIndex=1;
			break;
			case "original":
				$('#albumsize')[0].selectedIndex=2;
			break;
			default:
				$('#albumsize')[0].selectedIndex=0;
			break
		}		
	}else{
		$('#tr_albumsize').remove();
	}
	
	if($('strict',data).text().toLowerCase()=='yes'){
		$("#strict").attr('checked','checked');
	}else{
		$("#strict").removeAttr('checked');
	}
	if($('tivo',data).text().toLowerCase()=='yes'){
		$("#tivo").attr('checked','checked');
	}else{
		$("#tivo").removeAttr('checked');
	}
	$("#servername").val($('servername',data).text()); 
	$("#interval").val($('interval',data).text()/60); 
	var d=[];
	$('directory',data).each(function(){
		d.push( syspathToDavpath ( decodeURI($(this).text()) ) );
	});
	$("#scanfolder").val(   d.join(';') ); 
	enableService();
}


function toApply(){	
	if(!validate())return;	
	$("#waiting").show();
	var scanfolders=$("#scanfolder").val().split(';');
	var d=[];
	for(var i=0,l=scanfolders.length;i<l;i++){
		if(scanfolders[i].replace(/\s/g,'')!=='')d.push('directory='+encodeURI('/dav'+ scanfolders[i]));
	}
	d='?'+d.join('&');
	var data={
			hash:window.top.SessionID
			,enable:($("#check").attr('checked'))?'yes':'no'
			,strict:($("#strict").attr('checked'))?'yes':'no'
			,tivo:($("#tivo").attr('checked'))?'yes':'no'
			,servername:$("#servername").val()
			,interval:$("#interval").val()*60
			};
	if($('#albumsize')[0])data.album_art_size=$('#albumsize').val();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/set/dlna"+d
		,cache:false
		,data:data
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}


function rescan(){	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/rebuild/dlna"
		,cache:false
		,data:{
			hash:window.top.SessionID
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			alert('The system is rescanning...');
			$("#waiting").hide();
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}


function showBrowse(){
	window.top.System.selectDir({
		app:window.top.Preference
		,handler: function(path){
			var v=$("#scanfolder").val().split(';');
			v.push(decodeURI (path));
			$("#scanfolder").val( v.join(';')  );
		}
	}); 
}


function enableService(){
	if(($("#check").attr('checked'))){
		$("table input").removeAttr('disabled');
	}
	else{
		$("table input").attr('disabled','disabled');
	}
}


function validate(){
	var fields = [];

		fields.push({
			method : 'required',
			value : $('#scanfolder').val(), 
			element : $('#scanfolder')[0],
			param : null, 
			errParam : $.l10n.__("Preference_dlna_text_folder")
		},
		{
			method : 'required',
			value : $('#servername').val(), 
			element : $('#servername')[0],
			param : null, 
			errParam : $.l10n.__("Preference_dlna_text_servername")
		},
		{
			method : 'required',
			value : $('#interval').val(), 
			element : $('#interval')[0],
			param : null, 
			errParam : $.l10n.__("Preference_dlna_text_interval")
		},
		{
			method : 'digits',
			value : $('#interval').val(), 
			element : $('#interval')[0],
			param : null, 
			errParam :  $.l10n.__("Preference_dlna_text_interval")
		});

	return validateFields(fields);
}