﻿$(function(){
	$('#config').hide();
	window.App="Preference";
	loadLang();
	bindEvent();
	loadDYNData();	
	loadProxyData();
});



function bindEvent(){
	$("#REGISTER").click(toRegister);
	$("#dAPPLY").click(toApplyDYN);
	$("#dREFRESH").click(loadDYNData);
	$("#uAPPLY").click(toApplyUPnP);	
	$("#uREFRESH").click(loadProxyData);
	$("#check").click(function(){
		if($(this).is(':checked')){
			if($(this).attr('enabled')==='yes'&&$(this).attr('running')==='yes'){
				$('#config').show();
			}else{
				$('#config').hide();
			}
		}else{
			$('#config').hide();
		}
	});
}

function loadDYNData(){
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/dyndns"
		,cache:false
		,data:{
			hash:window.top.SessionID
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseDYNData(data);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});	
}


function loadProxyData(){
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/sockproxy"
		,cache:false
		,data:{hash:window.top.SessionID}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;			
			if($('enable',data).text().toLowerCase()=='yes'){
				$("#check").attr('checked','checked').attr('enabled','yes');
				$('#config').show();
				loadRegisterData();
				loadUPnPData();
			}else{
				$("#check").removeAttr('checked').attr('enabled','no');
				$('#config').hide();
			}
			if($('running',data).text().toLowerCase()=='yes'){
				$('#running').html('<label domain="l10n" msgid="Preference_main_text_servicerunning">'+$.l10n.__('Preference_main_text_servicerunning')+'</label>');
				$("#check").attr('running','yes');
			}else{
				$('#running').html('<label domain="l10n" msgid="Preference_main_text_servicestopped">'+$.l10n.__('Preference_main_text_servicestopped')+'</label>');
				$("#check").attr('running','no');
			}			
			var status=$('status',data).text().toLowerCase();
			if(status==='true')$('#sockporxy').html('Connected');
			else $('#sockporxy').html('Unconnected');
		}
	});
}


function parseDYNData(data){
	var hostname=[];
	$("hostname",data).each(function(){
		hostname.push($(this).text());
	});
	$("#hostname").val(hostname.join(','));
	$("#username").val($("username",data).text());
	$("#password").val($("password",data).text());
	var lastresp=$("lastresp",data).text();
	switch(lastresp){
		case 'badauth':
			$("#lastresp").html('<span domain="l10n" msgid="Preference_ddns_alert_badauth">'+$.l10n.__('Preference_ddns_alert_badauth')+'</span>');
		break;
		case 'nohost':
			$("#lastresp").html('<span domain="l10n" msgid="Preference_ddns_alert_nohost">'+$.l10n.__('Preference_ddns_alert_nohost')+'</span>');
		break;
		default:
			$("#lastresp").html(lastresp);
		break;
	}
}


function toApplyDYN(){
	if(!validateDYN())return;
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/set/dyndns"
		,cache:false
		,data:{
			hash:window.top.SessionID,
			hostname:$("#hostname").val().split(","),
			username:$("#username").val(),
			password:Crypt($('#password').val(),window.top.modulus,window.top.public)// $('#password').val()
		}
		,traditional:true
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			parseDYNData(data);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}

function validateDYN(){
	var fields = [
		{
			method : 'required',
			value : $('#hostname').val(), 
			element : $('#hostname')[0],
			param : null, 
			errParam : $.l10n.__("Preference_register_text_name")
		}
	];

	return validateFields(fields);
}





function loadUPnPData(){	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/upnp"
		,cache:false
		,data:{
			hash:window.top.SessionID
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseUPnPData(data);
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}



function parseUPnPData(data){
	var addr=$('addr',data).text();
	var port=$('port',data).text();
	var enable=$('enable',data).text();
	$("#port").val(port);
	if(addr!==''){
		window.top.NASinfo.upnp=addr+':'+port;
		$("#upnpaddr").html(window.top.NASinfo.upnp);
	}
	else{
		window.top.NASinfo.upnp='';
		$("#upnpaddr").html('no mapping');
	}
	if(enable==='yes')$('#upnpauto').attr('checked','checked');
	else $('#upnpauto').removeAttr('checked');
}



function toApplyUPnP(){
	var $check=$('#check');
	if($check.is(':checked')&&$check.attr('enabled')==='yes'&&$check.attr('running')==='yes'){
		setUPnP();
		return;
	}
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+'nas/set/sockproxy'
		,cache:false
		,data:{
			hash:window.top.SessionID
			,enable:($check.attr('checked'))?'yes':'no'}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			loadProxyData();
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}

function setUPnP(){
	if(!validateUPnP())return;	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/set/upnp"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,enable:($('#upnpauto').is(':checked'))?'yes':'no'
			,port:$("#port").val()
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseUPnPData(data);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}



function validateUPnP(){
	var fields = [];
	fields.push({
		method : 'required',
		value : $('#port').val(), 
		element : $('#port')[0],
		param : null, 
		errParam :$.l10n.__("Preference_upnp_text_port")
	},
	{
		method : 'range',
		value : $('#port').val(), 
		element : $('#port')[0],
		param : [1,65534], 
		errParam : [$.l10n.__("Preference_upnp_text_port"),1,65534]
	});

	
	return validateFields(fields);
}



function loadRegisterData(){
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/info"
		,cache:false
		,data:{
			hash:window.top.SessionID
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			var url=$("register",data).text();
			$("#registername").val(url);
			window.top.NASinfo.registername=url;
			window.top.document.title=window.top.NASinfo.registername;
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});		
}


//--------------------------------注册-------------------------------------------------------------
function toRegister(){
	if(!validateRegister())return;
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/register"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,name:$("#registername").val()
			,host:$.l10n.__('global_link_registerhost')
			,port:$.l10n.__('global_link_registerport')
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			window.top.NASinfo.registername=$("#registername").val();
			window.top.document.title=$("#registername").val();
			alert ( $.l10n.__("Preference_register_alert_ok") );

		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
	
	
	
}

function validateRegister(){
	var fields = [
		{
			method : 'required',
			value : $('#registername').val(), 
			element : $('#registername')[0],
			param : null, 
			errParam : $.l10n.__("Preference_register_text_name")
		},
		{
			method : 'regex',
			value : $('#registername').val(), 
			element : $('#registername')[0],
			param : '^[a-zA-Z0-9][a-zA-Z0-9-]{3,32}$', 
			errParam : $.l10n.__("Preference_register_text_name")
		}
	];

	return validateFields(fields);
}
