﻿$(function(){
	window.App="SocialNetwork";	
	loadLang();	
	layout();
	bindEvent();
	init();
});


function layout(){
	$('body').layout({ 
			center__paneSelector:"#main"
		,	north__paneSelector:"#top"  
		,	north__size:80
		,	north__spacing_open:0
		//,	center__minWidth:400
		,	contentSelector:".data"
	}); 
}

function bindEvent(){
	$('#login').unbind('click').click(function() {
		window.top.youtubetoken=null; 
		//window.open('http://myisharing.com/youtube.html?origin='+window.location.href,'isharing');
		var url='http://myisharing.com/youtube.html?origin='+window.location.href;
		document.getElementById('isharing').contentWindow.location.replace(url);
	});
	$('#UPLOAD').unbind().click(showUpload);		
	$('#REFRESH').unbind().click(init);
	$('#logout').unbind().click(toLogout);
	var win=window.win.mask;
	var thiswin=window; 
	window.top.$(win)
		.droppable('destroy')
		.droppable({
		accept:'#main li.file'
		,drop: function(event, ui) {
				var curWin=window.win;
				var $C;
				if(curWin.id=='App_MyNAS_Win_main')$C=window.top.MyNAS.mainWin.content.$C;
				if(curWin.id=='App_AlbumMaker_Win_main')$C=window.top.AlbumMaker.mainWin.content.$C; 
				var items=(ui.draggable.hasClass('image'))?[ui.draggable[0]]:null;
				if(ui.draggable.hasClass('selected')){
					var lis=window.top.$('li.selected.file',$C); 
					if(lis.length>0){
						items=null;
						items=lis; 
					}
				}
				if (!items)return;
				var itempaths=[]; 
				for(var i=0;i<items.length;i++){
					itempaths.push(items[i].getAttribute('webview').replace('?webview','?').replace('session='+window.top.SessionID,'').replace('login='+window.top.user,''));
				}; 
				thiswin.toUpload(itempaths);
		}
		,hoverClass: 'drophover'
	});	
}

function init(access_token){ 
	$('#logout,#REFRESH,#CREATE,#UPLOAD').hide();
	var access_token=getRequest('access_token');
	if(access_token&&access_token!==''){
		window.top.youtubetoken=access_token;
		window.parent.init();
		return;
	}
	if(window.top.youtubetoken){
		$('#login').hide();
		$('#logout,#REFRESH,#CREATE,#UPLOAD').show();
		loadData();
		return;
	}
	$('#login').show();
	$('#logout,#REFRESH,#CREATE,#UPLOAD').hide();
	$('#login').click();
}

function toLogout(){
	window.open('https://accounts.google.com/o/oauth2/revoke?token='+window.top.youtubetoken,'isharing');
	$('#login').show();
	$('#logout,#REFRESH,#CREATE,#UPLOAD').hide();
	$('#username').html('');
	$('#userphoto').attr('src','icons/user.gif');
	window.top.youtubetoken=null;
	$('#data').empty();
}

function loadData(){
	YT({
		url:'/youtube/v3/channels' 
		,part:'snippet,contentDetails'
		,mine:'true'
		,callback:'parseData'
	});
}

function parseData(json){	
	if(isError(json))return;
	var i=json.items[0];
	$('#username').html(i.snippet.title);
	$('#userphoto').attr('src',i.snippet.thumbnails.default.url); 
	var uploads_id=i.contentDetails.relatedPlaylists.uploads;
	loadVideos(uploads_id);
}

function loadVideos(id){
	YT({
		url:'/youtube/v3/playlistItems' 
		,playlistId:id
		,part:'snippet'
		,maxResults:'50' //最大50个
		,callback:'parseVideos'
	});
}

function parseVideos(json){
	if(isError(json))return;
	$('#data').empty();
	var items=json.items;
	for(var i=0,l=items.length;i<l;i++){
		var v=items[i].snippet;
		var thumb=v.thumbnails.default.url;
		var title=v.title;
		var link='https://www.youtube.com/watch?v='+v.resourceId.videoId;
		var div=document.createElement('div');
		var img=document.createElement('img');img.src=thumb;
		var label=document.createElement('label');label.innerHTML=title;
		$(div).append(img).append(label).appendTo($('#data'));
		$(div).click(function(){
			$('div.selected').removeClass('selected');
			$(this).addClass('selected');
		});
	}
}

function showUpload(){
	if(!window.top.youtubetoken)return;
	window.top.System.opendialog({
		app:window.top.SocialNetwork
		,filter:'media|*.*'
		,handler:toUpload
	});
}

function toUpload(items){
	var l=items.length;
	while(l--){
		$("#waiting").show();
		$.ajax({
			url: window.top.remoteDataUrl+"nas/youtube/upload"
			,cache:false
			,data:{
				hash:window.top.SessionID
				,access_token:window.top.youtubetoken
				,path:decodeURI(items[l])
			}
			,type: "POST"
			,dataType:'json'
			,success: function(data){
				$("#waiting").hide();
				if(window.top.checkAPIError(data))return;
				var id=data.id;
				var title=data.snippet.title;
				var thumb=data.snippet.thumbnails.default.url;
				var link='https://www.youtube.com/watch?v='+id;
				var div=document.createElement('div');
				var img=document.createElement('img');img.src=thumb;
				var label=document.createElement('label');label.innerHTML=title;
				$(div).append(img).append(label).appendTo($('#data'));
				$(div).click(function(){
					$('div.selected').removeClass('selected');
					$(this).addClass('selected');
				});
			}
			,error:function(data){
				$("#waiting").hide();
				alert ( $.l10n.__("global_alert_getdataerror") );
			}
			//,timeout:20000
			
		});
	}
}

function isError(json){
	if(json.error){
		if(json.error.code===401){
			$('#login').click();
		}else{
			alert ('System Error:\n\n'+json.error.code+'\n'+json.error.message);
		}
		return true;
	}
	return false;
}

function YT(data){
	data.access_token=window.top.youtubetoken;
	var url='https://www.googleapis.com'+data.url;
	delete(data.url);
	$('#waiting').show();
	$.ajax({
		url:url
		,dataType:'script'
		,data:data
		,complete:function(){
			$('#waiting').hide();
		}
	});
}